/*!
	CConnectionThreadManager

	ڑXbhǗNX
	Xbh̐s
*/

#pragma once
#include "ThreadSkeleton.h"
#include "IServerToolWrap.h"
#include "IClientConnection.h"
#include "ClientConnectionQueue.h"
#include "Settings.h"
#include "OverloadManager.h"
#include "CnotextManager.h"

#include "ConnectionThread.h"


/*!
	ڑ}l[W
*/
class CConnectionThreadManager :
	public CThreadSkeleton, protected IConnectionThreadParent
{
public:
	CConnectionThreadManager(void);
	virtual ~CConnectionThreadManager(void);

	/////////////////////////////////////////////////////////////////////////////////////
	//	
	/////////////////////////////////////////////////////////////////////////////////////
	//!	Jn
	void Start(CIServerToolWrap serverTool);

	//!	~
	void Stop();

	//!	I[o[[hC^tF[X擾
	IOverloadManagerPtr GetIOverloadManager() { return m_overload.GetIOverloadManager(); };

	//!	ڑL[C^tF[X擾
	IClientConnectionQueuePtr GetIClientConnectionQueue() { return m_queue.GetIClientConnectionQueue(); };

	//!	IConetextManager擾
	IConetextManagerPtr GetIConetextManager() { return m_context.GetIConetextManager(); };

protected:
	/////////////////////////////////////////////////////////////////////////////////////
	//	Xbh֐
	/////////////////////////////////////////////////////////////////////////////////////
	//!	Xbh
	void ThreadMain();

	//!	Vڑǉ
	void CreateNewThread(IClientConnectionAutoPtr connection);

	//!	ڑЕt
	void DeleteEndThreads();

	//!	őڑɓBH
	int InMaxThreads();

	//!	ڑ
	int GetThreadCount();

	/////////////////////////////////////////////////////////////////////////////////////
	//	IConnectionThreadParent
	/////////////////////////////////////////////////////////////////////////////////////
	//!	XbhI
	virtual void EndConnection(CConnectionThread *connectionPtr);

	//!	I[o[[h
	virtual int InOverloadMode();

	/////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	/////////////////////////////////////////////////////////////////////////////////////
	//!	tO
	CInterlockCounter				m_init;

	//!	ݒ
	CConnectionThreadManagerSetting	m_setting;

	//!	őڑ
	int								m_maxThreads;

	//!	T[oc[
	CIServerToolWrap				m_serverTool;

	//!	Xbh
	CSimpleArrayTemplate<CConnectionThreadAutoPtr>		m_threads;

	//!	IXbh
	int								m_endThreadCount;

	//!	ڑIDJE^
	int								m_connectionID;

	/////////////////////////////////////////////////////////////////////////////////////
	//	TuNX
	/////////////////////////////////////////////////////////////////////////////////////
	//!	I[o[[h
	COverloadManager				m_overload;

	//!	L[
	CClientConnectionQueue			m_queue;

	//!	ReLXg}l[W
	CCnotextManager					m_context;
};
