#pragma once
#include "IManagerInterface.h"
#include "IServerToolWrap.h"

/*!
	C^[tF[X}l[W
*/
class CInterfaceManager
{
public:
	CInterfaceManager(void);
	virtual ~CInterfaceManager(void);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	Jn
	void Start(CIServerToolWrap serverTool);

	//!	~
	void Stop();

	//!	C^tF[Xo^
	int RegisterInterface(CUTF8String interfaceName, IManagerInterfacePtr ifRegister, IManagerInterfacePtr *oldInterface = NULL);

	//!	C^[tF[Xo^
	int UnRegisterInterface(CUTF8String interfaceName, IManagerInterfacePtr ifUnRegister, IManagerInterfacePtr oldInterface = NULL);

	//!	C^tF[X擾
	void *GetInterface(CUTF8String interfaceName, int ifVersion);

protected:
	/////////////////////////////////////////////////////////////////////////////////
	//	⏕֐
	/////////////////////////////////////////////////////////////////////////////////
	//!	C^tF[Xo^
	int _RegisterInterface(CUTF8String interfaceName, IManagerInterfacePtr ifRegister, IManagerInterfacePtr *oldInterface = NULL);

	//!	
	int FindIndex(CUTF8String ifName);

	/////////////////////////////////////////////////////////////////////////////////
	//	NX
	/////////////////////////////////////////////////////////////////////////////////
	class CRegisterdInterface
	{
	public:
		CRegisterdInterface() {};
		CRegisterdInterface(CUTF8String interfaceName, IManagerInterfacePtr ifRegister)
		{
			m_interfaceName = interfaceName;
			m_interface = ifRegister;
		};

		//!	C^[tF[X
		CUTF8String					m_interfaceName;

		//!	C^[tF[X
		IManagerInterfacePtr	m_interface;
	};
	class CRegisterdInterfaceArray : public CSimpleArrayTemplate<CRegisterdInterface> {};

	/////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	/////////////////////////////////////////////////////////////////////////////////
	//!	tO
	CInterlockCounter			m_init;

	//!	NeBJZNV
	CSyncCriticalSection		m_scopeLock;

	//!	ۑ̃C^tF[X
	CRegisterdInterfaceArray	m_ifArray;
};

