#pragma once
#include "FilterBase.h"

#include "Settings.h"
#include "SyncObject.h"
#include "ILogManager.h"
#include "TextTools.h"

class CAccessLogFilter :
	public CFilterBase
{
public:
	CAccessLogFilter(void);
	virtual ~CAccessLogFilter(void);

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	eĂ΂
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	
	void Init(CIServerToolWrap serverTool);

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	tB^擾
	virtual LPCTSTR GetFilterName();

	//!	ؒf(OցI)
	virtual void Stop(CIConnectionToolWrap filterContext);

protected:
	//////////////////////////////////////////////////////////////////////////////////////////////
	//	Oo
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	`FbN
	int IsIgnore(CString serverPath);

	//!	O擾
	CString	GetLogFilePath(CContext &context);

	//!	O擾
	CString	GetLog(CContext &context);

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	NeBJZNV
	CCriticalSection			m_scopeLock;

	//!	T[oc[
	CIServerToolWrap			m_serverTool;

	//!	ݒ
	CAccessLogFilterSetting		m_setting;

	//!	O}l[W
	CILogManagerWrap			m_logManager;

	//!	t@CpX
	CLockObject<CString>		m_logFilePath;

	//!	t@CtH[}bg
	CLockObject<CString>		m_logFormat;

	//!	Url
	CStringArray				m_ignorePath;
};


class CAccessLogFilterFactory :
	public CFilterFactoryBase
{
public:
	CAccessLogFilterFactory(void) {};
	virtual ~CAccessLogFilterFactory(void) {};

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	IFilterFactory
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	tB^擾
	IFilterPtr GetFilter()
	{
		return m_filter.GetIFilter();
	};

	//!	
	virtual void Start(CIServerToolWrap serverTool)
	{
		m_filter.Init(serverTool);
	}

	//!	폜
	virtual void Delete() { delete this; }

protected:
	//////////////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	tB^
	CAccessLogFilter			m_filter;
};

